﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace Pacman01_2DArray
{
    class Program
    {
        static string[] mapS = {
            "##############",
            "#..#.###@...##",
            "##.#...#.##..#",
            "##.#.###.#####",
            "##<..........#",
            "##############"
                               };
        static char[][] map;
        static int moveX = 0;
        static int moveY = 0;
        static int playerPosX = 0;
        static int playerPosY = 0;
        static int oldPlayerPosX;
        static int oldPlayerPosY;
        static int score = 0;
        static int life = 1;

        static void Main(string[] args)
        {
            init();

            while (true)
            {
                processInput();
                update();
                render();
            }
        }

        static void init()
        {
            int cols = mapS[0].Length;
            int rows = mapS.Length;
            map = new char[rows][];
            for (int j = 0; j < rows; ++j)
            {
                map[j] = new char[cols];
                for (int i = 0; i < cols; ++i)
                    map[j][i] = mapS[j][i];
            }

            //draw level
            for (int i = 0; i < cols; ++i)
            {
                for (int j = 0; j < rows; ++j)
                {
                    System.Console.SetCursorPosition(i, j + 1);
                    char obj = map[j][i];
                    System.Console.Write(obj);
                    if (obj == '<')
                    {
                        playerPosX = i;
                        playerPosY = j;
                    }
                }
            }
            System.Console.SetCursorPosition(0, 0);
            System.Console.Write("Score: 0");
        }

        static void processInput()
        {
            moveX = 0;
            moveY = 0;

            if (System.Console.KeyAvailable)
            {
                ConsoleKeyInfo keyinfo = System.Console.ReadKey(true);
                if (keyinfo.Key == ConsoleKey.LeftArrow)
                    moveX -= 1;
                if (keyinfo.Key == ConsoleKey.RightArrow)
                    moveX += 1;
                if (keyinfo.Key == ConsoleKey.UpArrow)
                    moveY -= 1;
                if (keyinfo.Key == ConsoleKey.DownArrow)
                    moveY += 1;
                if (keyinfo.Key == ConsoleKey.Escape)
                    System.Environment.Exit(0);
            }
        }

        static void update()
        {
            oldPlayerPosX = playerPosX;
            oldPlayerPosY = playerPosY;
            int newPlayerPosX = playerPosX + moveX;
            int newPlayerPosY = playerPosY + moveY;

            char obj = map[newPlayerPosY][newPlayerPosX];
            if (obj != '#') //not a wall hit
            {
                if (obj == '.')
                {
                    score++;
                    map[newPlayerPosY][newPlayerPosX] = ' ';
                }
                else if (obj == '@')
                {
                    --life;
                    if (life <= 0)
                    {
                        System.Console.SetCursorPosition(0, 0);
                        System.Console.Write("GAME OVER");
                        System.Threading.Thread.Sleep(3000);
                        System.Environment.Exit(0);
                    }
                }
                playerPosX = newPlayerPosX;
                playerPosY = newPlayerPosY;
            }
        }

        static void render()
        {
            System.Console.SetCursorPosition(0, 0);
            System.Console.Write("Score: " + score);

            System.Console.SetCursorPosition(oldPlayerPosX, oldPlayerPosY + 1);
            System.Console.Write(" ");

            System.Console.SetCursorPosition(playerPosX, playerPosY + 1);
            System.Console.Write("<");
        }
    }
}